*
*	GrADS script to loop at a finer temporal resolution
*	than the data 
*
*	GrADS 1.3.7 command to reinitialize GrADS
* 
'reinit'
'set rgb 80 250 250 250'
'set rgb 81 242 242 242'
'set rgb 82 234 234 234'
'set rgb 83 226 226 226'
'set rgb 84 218 218 218'
'set rgb 85 210 210 210'
'set rgb 86 202 202 202'
'set rgb 87 194 194 194'
'set rgb 88 186 186 186'
'set rgb 89 178 178 178'
'set rgb 90 170 170 170'
'set rgb 91 162 162 162'
'set rgb 92 154 154 154'
'set rgb 93 146 146 146'
'set rgb 94 138 138 138'
'set rgb 95 130 130 130'
'set rgb 96 122 122 122'
'set rgb 97 114 114 114'
'set rgb 98 106 106 106'
'set rgb 99  98  98  98'
'set rgb 16  90  90  90'
'set rgb 17  82  82  82'
'set rgb 18  74  74  74'
'set rgb 19  66  66  66'   

*
*	open a data file
*
'open /metop1/previsao/modelos/ctl/cptec001.ctl'
*
*	define the display area
*
'set lat -60 0'
'set lon -140 -20'
*
*	dt 		the fine time increment
*	dtngps		the time increment of the data
dt=3
dtngps=12
*
*	pvar is the field to display
*
pvar='slp'
pvar2='v'

*
*	tbeg 	beginning time
*	tend	ending time
*
tbeg=0
tend=140
*
*	initialize the current time to the beginning time
*
t=tbeg
*
*	i1 and i2 are the time indices to interpolation betwee
*
i1=0
*
*	X command for doing double buffer graphics
*
'set dbuff on'
*
*	loop until the ending time
*
'set gxout shaded'
hora=1
'set t'1
while(t <= tend)
*
*	use the mod function to see if we need to
*	reset the time indices
* 

  itest=mod(t,dtngps)

  if(itest = 0)
    i1=i1+1
    i2=i1+1 
  endif
*
*	calculate the interpolation coefficients
*
  bfact=(t-dtngps*(i1-1))/dtngps
  afact=1.0-bfact
  if (t=6|t=12|t=18|t=24|t=48|t=72|t=96|t=120)
*    hora=hora-24
   h=(t/6)+1
   'set t 'h
  endif
  'q time'
   sres=subwrd(result,3)
   hour=substr(sres,1,3)
   day=substr(sres,4,2)
   month=substr(sres,6,3)
   year=substr(sres,11,2)
   week=subwrd(result,6)
   diaweek='Fri Sat Sun Mon Tue Wed Thu'
   diasemana='Sex Sab Dom Seg Ter Qua Qui'
   i=1
   j=1000
   while (i!=j)
         compara=subwrd(diaweek,i)
         if (week)=(compara)
            j=i
         else
            i=i+1
         endif
   endwhile
   _semana=subwrd(diasemana,j)
   monthyear='JAN FEB MAR APR MAY JUN JUL AUG SEP OCT NOV DEC'
   i=1
   j=1000
   while (i!=j)
         compara=subwrd(monthyear,i)
         if (month=compara)
             j=i
         else
             i=i+1
         endif
   endwhile
   mes=i
   if(hora=24)
       hora=00
    endif
*
*	define the interpolated field
* 
say   'define q='afact'*'pvar'(t='i1')+'bfact'*'pvar'(t='i2')'
      
  'define q='afact'*'pvar'(t='i1')+'bfact'*'pvar'(t='i2')'
*
*	display the data to the unseen buffer
* 
  'set cint 3'
  'set cmin 0'
  'd q'
*
*	swap buffers to display the plot on the screen
* 
  'swap'
*
*	bump the time by dt
*
  t=t+dt
 'draw string 4.5 0.5 'day'/'hour'/'mes'/'year'/'hora'Z' 
  hora=hora+1
endwhile
*
*	pause until the use hits c for clear or p for print or q for quit
*
rc=pause()
*
*	turn double buffering off
*
'set dbuff off'


function pause()
  while(1)
   pull keycmd
   if(keycmd='c')
     'c'
     break
   endif
   if(keycmd='p')
     'print'
     'c'
     break
   endif
   if(keycmd='q')
     'c'
     break
     'quit'
   endif
 endwhile
return

function mod(i0,inc)
  if(inc!=0)
    imod=int(i0/inc)
  else
    imod=int(i0/1)
  endif
  imod=i0-imod*inc
return(imod)

function int(i0)
  i=0
  while(i<12)
    i=i+1
    if(substr(i0,i,1)='.')
      i0=substr(i0,1,i-1)
      break
    endif
  endwhile
return(i0)

